LOADER 	ORG	4200H
 LOADER	DI
 	LD	(HL),0D0H
 	LD	HL,TITLE
 	LD	SP,$
 	CALL	PRINT
 	LD	BC,4000H	;LOAD ADDRESS
 	LD	DE,1		;TRACK 0/ SECTOR 1
 	LD	L,2		;SECTOR COUNT
 	LD	SP,$
 	CALL	MREAD
 	LD	BC,4300H	;DRIVER START
 	LD	DE,4		;START SECTOR 4
 	LD	L,10		;SECTOR COUNT
 	CALL	MREAD		;MULTIPLE SECTOR READ
 	JP	4033H		;INTERCEPT INITIALIZATION
 MREAD	PUSH	HL		;SAVE COUNT
 	CALL	READ		;READ THE SECTOR
 	JP	NZ,ERROR	;READ ERROR
 	POP	HL		;RESTORE COUNT
 	DEC	L		;LESS ONE
 	RET	Z		;DONE
 	INC	E		;BUMP SECTOR
 	LD	A,E
 	CP	10		;END OF TRACK ?
 	JR	NZ,MREAD	;NOPE
 	LD	E,A		;ZERO E
 	INC	D		;BUMP TRACK
 	JR	MREAD		;CONTINUE
 READ	CALL	SELECT		;SELECT DRIVE 0
 	LD	(37EEH),DE	;LOOKING FOR TRACK
 	LD	HL,37ECH	;FDC ADDRESS
 	LD	(HL),1BH	;SEEK THE TRACK
 	CALL	DSKSLO		;WAIT FOR READY
 SEEKWT	BIT	0,(HL)		;IN PROGRESS ?
 	JR	NZ,SEEKWT	;WAIT TILL FOUND
 	LD	(HL),88H	;READ COMMAND
 	PUSH	DE		;SAVE TRACK SECTOR
 	LD	DE,37EFH	;TRANSFER ADDRESS
 	CALL	DSKSLO		;WAIT
 	JR	READBZ		;CHECK FOR BUSY
 READCK	BIT	0,(HL)		;DONE ?
 	JR	Z,READDN	;YES IF NOT SET
 READBZ	BIT	1,(HL)		;BYTE READY ?
 	JR	Z,READCK	;WAIT SOME MORE
 	LD	A,(DE)		;BYTE FROM FDC
 	LD	(BC),A		;PUT IN BUFFER
 	INC	BC		;BUMP POINTER
 	JR	READBZ		;CONTINUE
 READDN	LD	A,(HL)		;GET STATUS
 	LD	(HL),0D0H	;FORCE INTERRUPT
 	AND	5CH		;CHECK FOR ERROR
 	RET			;DONE
 ERROR	LD	HL,ERMSG	;ERROR MESSAGE
 	CALL	PRINT		;SHOW IT
 	CALL	40H		;WAIT FOR KEYBOARD
 	HALT			;RE-BOOT
 PRINT	PUSH	HL		;SAVE MESSAGE POINTER
 	LD	HL,3C00H	;CLEAR SCREEN
 	LD	DE,3C01H
 	PUSH	HL		;SAVE FOR PRINT
 	LD	BC,1023
 	LD	(HL),20H
 	LDIR
 	XOR	A
 	OUT	(0FFH),A
 	POP	DE		;DE=VIDEO
 	POP	HL
 PRLOP	LD	A,(HL)
 	INC	HL		;BUMP POINTER
 	OR	A		;TEST FOR TERMINATOR
 	RET	Z		;DONE
 	LD	(DE),A		;PUT ON SCREEN
 	INC	DE		;BUMP SCREEN
 	JR	PRLOP		;GO LOOP
 SELECT	LD	A,(37ECH)	;GET STATUS
 	BIT	7,A		;IF MOTOR ON
 	LD	A,1		;SELECT DRIVE 0
 	LD	(37E1H),A	;DO IT
 	RET	Z		;DRIVE ALREADY ON
 	PUSH	BC		;SAVE BC
 	LD	BC,4000H	;WAIT 1/4 SECOND
 DELAY	DEC	C
 	JR	NZ,DELAY
 	DJNZ	DELAY		;GO LOOP
 	POP	BC		;RESTORE
 	LD	A,(37ECH)	;GET STATUS AGAIN
 	BIT	7,A		;IS IT READY NOW?
 	RET	Z		;YES
 	JP	ERROR		;DISK ERROR
 DSKSLO	EX	(SP),HL
 	EX	(SP),HL
 	EX	(SP),HL
 	EX	(SP),HL
 	RET
 ERMSG	DB	'Disk Read Error ',0
 TITLE	DB	'Loading Super-Utility II',0
 	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 	END
YES
 	JP	ERROR